import 'package:e_commerce/firebase_options.dart';
import 'package:e_commerce/ui/splash_screen.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await Firebase.initializeApp(
    options: DefaultFirebaseOptions.currentPlatform,
  );
  runApp(
    MyApp(),
  );
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return ScreenUtilInit(
      designSize: const Size(375, 812),
      minTextAdapt: true,
      splitScreenMode: true,
      builder: (context, child) {
        return MaterialApp(
          debugShowCheckedModeBanner: false,
          title: 'Flutter PojokTI',
          theme: ThemeData(
            primarySwatch: Colors.blue,
            visualDensity: VisualDensity
                .adaptivePlatformDensity, // Adjust for different platforms
          ),
          home: child,
        );
      },
      child: SplashScreen(), // SplashScreen as child
    );
  }
}

